// InfoSearchWnd.cpp :  Դϴ.
//

#include "stdafx.h"
#include "NeMessenger.h"
#include "InfoSearchWnd.h"

// CInfoSearchWnd
IMPLEMENT_DYNAMIC(CInfoSearchWnd, CWnd)

CInfoSearchWnd::CInfoSearchWnd()
{
	// BG
	m_pImgBG = NULL;
	m_pImgSearch = NULL;
	m_pImgSearchOver = NULL;
	m_pImgSearchClick = NULL;

	// dimension
	m_rtWnd.SetRectEmpty();
	m_rtSearch.SetRectEmpty();
	m_rtEdit.SetRectEmpty();
	m_rtSearchText.SetRectEmpty();

	// edit
	m_strIntroducing = _T("");
	m_bEditSearch = FALSE;
	m_pEditBkBrush = new CBrush(DEF_EDIT_COLOR_BG);
	m_crEditBk = DEF_EDIT_COLOR_BG;
	m_nEditPosTopY = DEF_EDIT_REL_TOP_POS_Y;

	// attribute
	m_strSearchText = _T("");
	m_bResetSearchText = TRUE;	// ˻ Ϸ  ˻ ʱȭ 

	// tracking
	m_bTracking = FALSE;
	m_bHoverSearch = FALSE;
	m_bDownSearch = FALSE;

	m_bSearchChatRoom = FALSE;
}

CInfoSearchWnd::~CInfoSearchWnd()
{
	SAFE_DELETE(m_pImgBG);
	SAFE_DELETE(m_pImgSearch);
	SAFE_DELETE(m_pImgSearchOver);
	SAFE_DELETE(m_pImgSearchClick);

	m_pEditBkBrush->DeleteObject();
	SAFE_DELETE(m_pEditBkBrush);
}

BEGIN_MESSAGE_MAP(CInfoSearchWnd, CWnd)
	ON_WM_CREATE()
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	ON_WM_MOUSEHOVER()
	ON_WM_MOUSELEAVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_SIZE()
	//ON_MESSAGE(WM_MOUSEHOVER,			OnMouseHover)
	//ON_MESSAGE(WM_MOUSELEAVE,			OnMouseLeave)
	ON_WM_SETCURSOR()
	ON_WM_DESTROY()
	ON_WM_CTLCOLOR()
	ON_EN_UPDATE(ID_EDIT_SEARCH_ITEM, OnEditUpdate)
END_MESSAGE_MAP()

int CInfoSearchWnd::GetImgBGWidth()
{
	int nImgWidth = 0;
	if (m_pImgBG)
		nImgWidth = m_pImgBG->GetWidth();

	return nImgWidth;
}

int CInfoSearchWnd::GetImgBGHeight()
{
	int nImgHeight = 0;
	if (m_pImgBG)
		nImgHeight = m_pImgBG->GetHeight();

	return nImgHeight;
}

void CInfoSearchWnd::SetImgBGPath(CString strFileName)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);

	m_pImgBG = new Image(strImgPath);
}

void CInfoSearchWnd::SetImgSearchPath(CString strFileName, CString strFileNameOver, CString strFileNameClick)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);
	m_pImgSearch = new Image(strImgPath);

	if (strFileNameOver.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileNameOver);
	m_pImgSearchOver = new Image(strImgPath);

	if (strFileNameClick.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileNameClick);
	m_pImgSearchClick = new Image(strImgPath);
}

void CInfoSearchWnd::SetEditSearch(BOOL bEdit)
{
	if (NULL == m_edit.GetSafeHwnd())
	{
		return;
	}

	m_bEditSearch = bEdit;

	if (m_bEditSearch)
	{
		m_edit.ShowWindow(SW_SHOW);
		m_edit.SetWindowText(m_strSearchText);
		m_edit.SetFocus();
		m_edit.SetSel(0, -1);
	}
	else
	{
		m_edit.ShowWindow(SW_HIDE);
	}

	RedrawWindow(&m_rtEdit, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

// CInfoSearchWnd ޽ óԴϴ.
int CInfoSearchWnd::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_edit.Create(WS_CHILD | ES_AUTOHSCROLL, m_rtEdit, this, ID_EDIT_SEARCH_ITEM))
		return -1;

	m_edit.SetFont(&g_ftDefault9PT);

	return 0;
}

BOOL CInfoSearchWnd::OnEraseBkgnd(CDC* pDC)
{
	return TRUE;
}

void CInfoSearchWnd::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	
	PAINTSTRUCT ps = dc.m_ps;
	int psWidth = ps.rcPaint.right - ps.rcPaint.left;
	int psHeight = ps.rcPaint.bottom - ps.rcPaint.top;

	int nPX = ps.rcPaint.left;
	int nPY = ps.rcPaint.top;

	CRect rtPS(nPX, nPY, nPX + psWidth, nPY + psHeight);

	CRect rt(0, 0, 0, 0);
	GetClientRect(&rt);
	//int nWndWidth = rt.Width();
	//int nWndHeight = rt.Height();

	HDC hdc = dc.GetSafeHdc();

	HDC	hdcMemory = CreateCompatibleDC(hdc);

	if (hdcMemory == NULL)
		return;

	HBITMAP hbmpMem = CreateCompatibleBitmap(hdc, psWidth, psHeight);

	HGDIOBJ hbmpOld = ::SelectObject(hdcMemory,  hbmpMem);

	Graphics graph(hdcMemory);

	if (hbmpMem)
	{
		//graph.SetSmoothingMode(SmoothingModeAntiAlias);
		//graph.SetInterpolationMode(InterpolationModeHighQualityBicubic);
		graph.SetPageUnit(UnitPixel);

		ImageAttributes ImgAttr;

/*
		ImageAttributes ImgAttr2;
		ColorMatrix matrix2 = {	1.05f, 0.00f, 0.00f, 0.00f, 0.00f,
			0.00f, 1.05f, 0.00f, 0.00f, 0.00f,
			0.00f, 0.00f, 1.05f, 0.00f, 0.00f,
			0.00f, 0.00f, 0.00f, 1.00f, 0.00f,
			0.05f, 0.05f, 0.05f, 0.00f, 1.00f };
		ImgAttr2.SetColorMatrix(&matrix2);

		ImageAttributes ImgAttr3;
		ColorMatrix matrix3 = {	0.95f, 0.00f, 0.00f, 0.00f, 0.00f,
			0.00f, 0.95f, 0.00f, 0.00f, 0.00f,
			0.00f, 0.00f, 0.95f, 0.00f, 0.00f,
			0.00f, 0.00f, 0.00f, 1.00f, 0.00f,
			0.05f, 0.05f, 0.05f, 0.00f, 1.00f };
		ImgAttr3.SetColorMatrix(&matrix3);
*/

		ImageAttributes* pImgAttr = &ImgAttr;

		if (m_pImgBG)
			DrawImageToStretchHorz(&graph, m_pImgBG, &rtPS, &m_rtWnd, Color(255, 200, 200, 200), &ImgAttr);

		Image* pImgSearch = m_pImgSearch;
		if (m_bHoverSearch)
		{
			pImgSearch = m_pImgSearchOver;
			if (m_bDownSearch)
				pImgSearch = m_pImgSearchClick;
		}
		if (pImgSearch)
			DrawImageToDest(&graph, pImgSearch, &rtPS, &m_rtSearch, pImgAttr);

		if (m_strSearchText.IsEmpty() || !m_bResetSearchText)
		{
			//int i = 0;
			CRect rtEdit = m_rtEdit;
			rtEdit.left -= 1;
			DrawTextToDest2(&graph,
						   m_strIntroducing, &rtPS, &rtEdit,
						   g_defaultFontFaceName, 9,
						   StringAlignmentNear,
						   FontStyleRegular,
						   Color(255, 128, 130, 127));
		}

		BitBlt(dc.GetSafeHdc(), nPX, nPY, psWidth, psHeight, hdcMemory, 0, 0, SRCCOPY);

		::SelectObject(hdcMemory, hbmpOld);
		::DeleteObject(hbmpMem);
	}

	::DeleteDC(hdcMemory);
}

void CInfoSearchWnd::OnMouseMove(UINT nFlags, CPoint point)
{
	BOOL bHoverSearch = FALSE;

	//::SetCursor(::LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW)));
	if (m_rtSearch.PtInRect(point))
	{
		bHoverSearch = TRUE;
	}

	if (!m_bTracking)
	{
		m_bTracking = TRUE;

		TRACKMOUSEEVENT tme;
		tme.cbSize = sizeof(TRACKMOUSEEVENT);
		tme.dwFlags = TME_HOVER | TME_LEAVE;
		tme.dwHoverTime = 1;
		tme.hwndTrack = GetSafeHwnd();
		TrackMouseEvent(&tme);
	}

	if (m_bHoverSearch != bHoverSearch)
	{
		m_bHoverSearch = bHoverSearch;

		RedrawWindow(&m_rtSearch, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
	}

	CWnd::OnMouseMove(nFlags, point);
}

void CInfoSearchWnd::OnMouseHover(UINT nFlags, CPoint point)
{

	CWnd::OnMouseHover(nFlags, point);
}

void CInfoSearchWnd::OnMouseLeave()
{
	m_bTracking = FALSE;
	m_bHoverSearch = FALSE;
	
	RedrawWindow(&m_rtSearch, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

void CInfoSearchWnd::OnLButtonDown(UINT nFlags, CPoint point)
{
	SetFocus();

	SetCapture();

	if (m_rtSearch.PtInRect(point))
	{
		m_bDownSearch = TRUE;
		RedrawWindow(&m_rtSearch, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);

		if (!m_bResetSearchText)
		{
			m_edit.GetWindowText(m_strSearchText);
			SetIntroducingText(m_strSearchText);
			SetEditSearch(FALSE);
		}
	}
	else if (m_rtEdit.PtInRect(point))
	{
		SetEditSearch(TRUE);
	}

	CWnd::OnLButtonDown(nFlags, point);
}

void CInfoSearchWnd::OnLButtonUp(UINT nFlags, CPoint point)
{
	ReleaseCapture();

	if (m_bDownSearch && m_rtSearch.PtInRect(point))
	{
		CWnd* pWndParent = GetParent();
		if (pWndParent && pWndParent->GetSafeHwnd())
		{
			m_edit.GetWindowText(m_strSearchText);
			pWndParent->SendMessage(WM_COMMAND, (WPARAM)GetDlgCtrlID(), (LPARAM)0);

		}

		if (m_bResetSearchText)
		{
			SetIntroducingText();
			SetSearchText(_T(""));
		}

		SetEditSearch(FALSE);
	}

	m_bDownSearch = FALSE;
	RedrawWindow(&m_rtSearch, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);

	CWnd::OnLButtonUp(nFlags, point);
}

void CInfoSearchWnd::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);

	m_rtWnd.SetRect(0, 0, cx, cy);

	int nImgWidth = 0, nImgHeight = 0;
	int nSX = 0, nSY = 0;
	int nEX = 0, nEY = 0;
	if (m_pImgSearch)
	{
		nImgWidth = m_pImgSearch->GetWidth();
		nImgHeight = m_pImgSearch->GetHeight();

		nSX = m_rtWnd.right - nImgWidth;
		nSY = m_rtWnd.top;
		m_rtSearch.SetRect(nSX, nSY, nSX + nImgWidth, m_rtWnd.bottom);
	}

	m_rtSearchText = m_rtWnd;
	m_rtSearchText.right = m_rtSearch.left;

	m_rtEdit = m_rtSearchText;
	m_rtEdit.left += DEF_TITLE_REL_LEFT_POS_X;
	m_rtEdit.right -= DEF_TITLE_REL_RIGHT_POS_X;

	m_rtEdit.top += m_nEditPosTopY + 2;
	m_rtEdit.bottom -= m_nEditPosTopY;

	if (m_edit.GetSafeHwnd())
		m_edit.MoveWindow(&m_rtEdit);
}

BOOL CInfoSearchWnd::OnCommand(WPARAM wParam, LPARAM lParam)
{
	UINT notificationCode = (UINT)HIWORD(wParam);

	switch (notificationCode)
	{
	case EN_KILLFOCUS:
		{
			if (m_bResetSearchText)
			{
				SetIntroducingText();
				SetSearchText(_T(""));
			}

			SetEditSearch(FALSE);
			return TRUE;
		}
		break;
	case EN_SETFOCUS:
		{
		}
		break;
	}

	return CWnd::OnCommand(wParam, lParam);
}

BOOL CInfoSearchWnd::PreTranslateMessage(MSG* pMsg)
{
    if (m_ToolTip.GetSafeHwnd() != NULL)
        m_ToolTip.RelayEvent(pMsg);

	if (pMsg->message == WM_KEYDOWN)
	{
		switch (pMsg->wParam)
		{
		case VK_RETURN:
			{
				CWnd* pWndFocus = GetFocus();
				if (pWndFocus->GetDlgCtrlID() == ID_EDIT_SEARCH_ITEM)
				{
					CWnd* pWndParent = GetParent();
					if (pWndParent && pWndParent->GetSafeHwnd())
					{
						m_edit.GetWindowText(m_strSearchText);
						m_strIntroducing = m_strSearchText;
						pWndParent->SendMessage(WM_COMMAND, (WPARAM)GetDlgCtrlID(), (LPARAM)0);
					}

					if (m_bResetSearchText)
					{
						SetIntroducingText();
						SetSearchText(_T(""));
					}

					SetEditSearch(FALSE);
					return TRUE;
				}
			}
			break;
		case VK_ESCAPE:
			{
				if (m_bResetSearchText)
				{
					SetIntroducingText();
					SetSearchText(_T(""));
				}

				if(m_bEditSearch)
				{
					SetEditSearch(FALSE);
					return TRUE;
				}
			}
			break;
		}
	}

	return CWnd::PreTranslateMessage(pMsg);
}

BOOL CInfoSearchWnd::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
	CPoint pt(0, 0);
	GetCursorPos(&pt);
	ScreenToClient(&pt);

	if (m_rtEdit.PtInRect(pt))
	{
		::SetCursor((HCURSOR)GetClassLong(m_edit.GetSafeHwnd(), GCL_HCURSOR));
		return TRUE;
	}

	if(m_rtSearch.PtInRect(pt))
	{
		::SetCursor(::LoadCursor(NULL, MAKEINTRESOURCE(IDC_HAND)));
		return TRUE;
	}

	return CWnd::OnSetCursor(pWnd, nHitTest, message);
}

void CInfoSearchWnd::OnDestroy()
{
	CWnd::OnDestroy();
}

void CInfoSearchWnd::SetResetSearchText(BOOL bCleanAfterSearch)
{
	m_bResetSearchText = bCleanAfterSearch;
}

HBRUSH CInfoSearchWnd::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CWnd::OnCtlColor(pDC, pWnd, nCtlColor);

	if( nCtlColor == CTLCOLOR_EDIT )
	{
		pDC->SetBkColor(m_crEditBk);
		return (HBRUSH)(m_pEditBkBrush->GetSafeHandle());
	}

	return hbr;
}

void CInfoSearchWnd::SetEditFont( CFont* pFont )
{
	m_edit.SetFont(pFont);

}

void CInfoSearchWnd::SetEditPosTopY(int nPosTopY)
{
	m_nEditPosTopY = nPosTopY;
}

void CInfoSearchWnd::SetEditBkColor(COLORREF crBk)
{
	m_pEditBkBrush->DeleteObject();
	m_pEditBkBrush->CreateSolidBrush(crBk);
	m_crEditBk = crBk;
}

void CInfoSearchWnd::SetIntroducingText(CString strIntroduce)
{
	if (strIntroduce.IsEmpty())
		m_strIntroducing = m_strDefault;
	else 
		m_strIntroducing = strIntroduce;
}

void CInfoSearchWnd::ShowIntroducingText()
{
	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW);
}

void CInfoSearchWnd::OnEditUpdate()
{
	if (FALSE == m_bSearchChatRoom)
		return;

	CString strSearchText = _T("");
	m_edit.GetWindowText(strSearchText);
	
	//  ˻ ִ ¿   
	if (!m_strSearchText.IsEmpty()  && strSearchText.IsEmpty())
	{
		m_strSearchText = strSearchText;

		CWnd* pWndParent = GetParent();
		if (pWndParent && pWndParent->GetSafeHwnd())
		{
			pWndParent->SendMessage(WM_COMMAND, (WPARAM)GetDlgCtrlID(), (LPARAM)0);
		}
	}
}

void CInfoSearchWnd::SetToolTipText(const CString& strText)
{
    if (m_ToolTip.GetSafeHwnd() == NULL)
    {
        m_ToolTip.Create(this);
        m_ToolTip.Activate(TRUE);
    }
    m_ToolTip.AddTool(this, (LPCTSTR)strText);
}
